unit uVrtDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, ExtCtrls, ComCtrls, DBCtrls,
  Buttons, TypInfo, Menus, uCVrtGrd, uVrtGrid;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    cmbDatabase: TComboBox;
    Label2: TLabel;
    cmbTable: TComboBox;
    tblTable: TTable;
    dsTable: TDataSource;
    PageControl1: TPageControl;
    tabGrid: TTabSheet;
    tabProperties: TTabSheet;
    grdTable: TVerticalGrid;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    grdProperty: TVerticalGrid;
    Panel4: TPanel;
    Label3: TLabel;
    btnCancel: TSpeedButton;
    btnSave: TSpeedButton;
    btnAdd: TBitBtn;
    btnDelete: TBitBtn;
    memPickList: TMemo;
    TabSheet1: TTabSheet;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    procedure cmbDatabaseDropDown(Sender: TObject);
    procedure cmbTableDropDown(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure cmbDatabaseChange(Sender: TObject);
    procedure cmbTableChange(Sender: TObject);
    procedure grdPropertyAlignmentGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyAlignmentSetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyButtonStyleGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyButtonStyleSetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyDropDownRowsGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyDropDownRowsSetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyEditMaskGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyEditMaskSetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyFieldNameGetEditText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyFieldNameSetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyFieldNameValidate(Sender: TObject; ARow: Integer;
      PickList: TStrings; var Value: Variant; var Accept: Boolean);
    procedure grdPropertyFieldNameGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyReadOnlyGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyReadOnlySetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyReadOnlyValidate(Sender: TObject; ARow: Integer;
      PickList: TStrings; var Value: Variant; var Accept: Boolean);
    procedure grdPropertyTextGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyTextSetText(Sender: TObject; ARow: Integer;
      Modified : Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyTitleGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure grdPropertyTitleSetText(Sender: TObject; ARow: Integer;
      Modified: Boolean; PickList: TStrings; const Value: Variant);
    procedure grdPropertyPickListEditButtonClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure tabPropertiesEnter(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure memPickListExit(Sender: TObject);
    procedure memPickListChange(Sender: TObject);
    procedure Panel4Resize(Sender: TObject);
    procedure grdPropertyPickListGetText(Sender: TObject; ACol,
      ARow: Integer; PickList: TStrings; var Value: Variant);
    procedure btnAddClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure grdTableSpecialEdit(Sender: TObject; ARow: Integer;
      Field: TField);
    procedure grdTableEditButtonClick(Sender: TObject; ARow: Integer;
      Field: TField);
  private
    { Private declarations }
    procedure grdTableLoadColumns;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.cmbDatabaseDropDown(Sender: TObject);
begin
     Session.GetAliasNames(cmbDatabase.Items);
end;

procedure TForm1.cmbTableDropDown(Sender: TObject);
begin
     Session.GetTableNames(cmbDatabase.Text,'',True,False,cmbTable.Items);
end;

Function Min(X,Y : Variant) : Variant;
Begin
     IF X < Y Then Result := X Else Result := Y;
End;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
     cmbTable.Width := Min(Panel1.Width - 16,220);
     cmbDatabase.Width := Min(Panel1.Width - 16,220);
end;


procedure TForm1.cmbDatabaseChange(Sender: TObject);
begin
     tblTable.Active := False;
     grdTable.Reset;
     cmbTable.Text := '';
     cmbTable.Enabled := (cmbDatabase.Text <> '');
end;

procedure TForm1.grdTableLoadColumns;
Var
   nCnt : Integer;
Begin
     tblTable.DisableControls;

     For nCnt := 0 to tblTable.FieldCount - 1 Do
     Begin
          grdTable.Columns.Add;
          With grdTable.Columns[nCnt] Do
          Begin
               FieldName := tblTable.Fields[nCnt].FieldName;
               AlignMent := taLeftJustify;
          End;
     End;

     tblTable.EnableControls;
     grdProperty.Invalidate;
End;

procedure TForm1.cmbTableChange(Sender: TObject);
begin
     tblTable.Active := False;
     grdTable.Reset;
     IF cmbTable.Text <> '' Then
     Begin
          tblTable.DatabaseName := cmbDatabase.Text;
          tblTable.TableName := cmbTable.Text;
          tblTable.Active := True;
          grdTableLoadColumns;
     End;
end;


procedure TForm1.grdPropertyAlignmentGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := PickList[Ord(Columns[Row].Alignment)];
end;

procedure TForm1.grdPropertyAlignmentSetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].Alignment := TAlignment(PickList.IndexOf(Value)) ;

end;

procedure TForm1.grdPropertyButtonStyleGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := PickList[Ord(Columns[Row].ButtonStyle)];
end;

procedure TForm1.grdPropertyButtonStyleSetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].ButtonStyle := TColumnButtonStyle(PickList.IndexOf(Value)) ;
end;

procedure TForm1.grdPropertyDropDownRowsGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := Columns[Row].DropDownRows;
end;

procedure TForm1.grdPropertyDropDownRowsSetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].DropDownRows := Value

     { Note that the new value is set in the OnSetText event which is called once
       only after the editing is done and not on every keystroke as in the OnSetEditText
       event }
end;

procedure TForm1.grdPropertyEditMaskGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := Columns[Row].EditMask;
end;

procedure TForm1.grdPropertyEditMaskSetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].EditMask := Value;
end;

procedure TForm1.grdPropertyFieldNameGetEditText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
Var
   nCnt : Integer;
begin
     For nCnt := 0 to tblTable.FieldCount -1 Do
     Begin
          PickList.Add(tblTable.Fields[nCnt].FieldName);
     End;

     With grdTable Do
          Value := Columns[Row].FieldName;
end;

procedure TForm1.grdPropertyFieldNameSetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].FieldName := Value;
end;

procedure TForm1.grdPropertyFieldNameValidate(Sender: TObject;
  ARow: Integer; PickList: TStrings; var Value: Variant;
  var Accept: Boolean);
begin
     Accept := (Value = '') or (PickList.IndexOf(Value) <> -1)
end;

procedure TForm1.grdPropertyFieldNameGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := Columns[Row].FieldName;
end;

procedure TForm1.grdPropertyReadOnlyGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := PickList[Ord(Columns[Row].ReadOnly)];
end;

procedure TForm1.grdPropertyReadOnlySetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].ReadOnly := Boolean(PickList.IndexOf(Value));
end;

procedure TForm1.grdPropertyReadOnlyValidate(Sender: TObject;
  ARow: Integer; PickList: TStrings; var Value: Variant;
  var Accept: Boolean);
begin
     Accept := (PickList.IndexOf(Value) <> -1)
end;

procedure TForm1.grdPropertyTextGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := Columns[Row].Text;
end;

procedure TForm1.grdPropertyTextSetText(Sender: TObject; ARow: Integer;
  Modified : Boolean; PickList: TStrings; const Value: Variant);
begin
     IF Modified Then
        With grdTable Do
             Columns[Row].Text := Value;

     { Check modified because "FieldName"  is Cleared if the "Text" or Public "Value"
       property is assigned }

     grdProperty.Columns['FieldName'].Refresh;

     { As shown above : The columns index can be specified as an Integer or as the
       Title of the Column - like fieldnames for datasets in Delphi 3 }

end;

procedure TForm1.grdPropertyTitleGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     With grdTable Do
          Value := Columns[Row].Title;
end;

procedure TForm1.grdPropertyTitleSetText(Sender: TObject; ARow: Integer;
  Modified: Boolean; PickList: TStrings; const Value: Variant);
begin
     With grdTable Do
          Columns[Row].Title := Value;
end;

procedure TForm1.grdPropertyPickListEditButtonClick(Sender: TObject);
begin
     MemPickList.Enabled := True;
     MemPickList.SetFocus;
end;

procedure TForm1.btnSaveClick(Sender: TObject);
begin
     With grdTable Do
          Columns[Row].PickList.Assign(memPickList.Lines);
     memPickListExit(Sender);
     grdProperty.SetFocus;
end;

procedure TForm1.tabPropertiesEnter(Sender: TObject);
begin
     memPickList.Visible := True;
     memPickList.Enabled := False;
     memPickList.Lines.Clear;
     With grdTable Do
          memPickList.Lines.Assign(Columns[Row].PickList);
end;

procedure TForm1.btnCancelClick(Sender: TObject);
begin
     memPickList.Lines.Clear;
     With grdTable Do
          memPickList.Lines.Assign(Columns[Row].PickList);
     memPickListExit(Sender);
     grdProperty.Setfocus;
end;

procedure TForm1.memPickListExit(Sender: TObject);
begin
     btnSave.Enabled := False;
     btnCancel.Enabled := False;
     memPickList.Enabled := False;
end;

procedure TForm1.memPickListChange(Sender: TObject);
begin
     btnCancel.Enabled := True;
     btnSave.Enabled := True;
end;

procedure TForm1.Panel4Resize(Sender: TObject);
begin
     memPickList.Width := Panel4.Width - 30;
     memPickList.Height := Panel4.Height - 70;
     btnAdd.Top := Panel4.Height - 32;
     btnDelete.Top := btnAdd.Top;
     btnSave.Left := Panel4.Width - 27;
     btnSave.Top  := memPicklist.Height;
     btnCancel.Left := btnSave.Left;
     btnCancel.Top  := memPicklist.Height - 32;
     btnAdd.Left := Panel4.Width - 86;
     btnDelete.Left := Panel4.Width - 174;
end;

procedure TForm1.grdPropertyPickListGetText(Sender: TObject; ACol,
  ARow: Integer; PickList: TStrings; var Value: Variant);
begin
     Value := '(TStrings)'
end;

procedure TForm1.btnAddClick(Sender: TObject);
begin
     grdTable.Columns.Add;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
     grdTable.Columns.Delete(grdTable.Row);
end;


procedure TForm1.grdTableSpecialEdit(Sender: TObject; ARow: Integer;
  Field: TField);
begin
     MessageBeep(0);
end;

procedure TForm1.grdTableEditButtonClick(Sender: TObject; ARow: Integer;
  Field: TField);
begin
     MessageDlg('Custom Edit behaviour implemented at Grid level',mtInformation,[mbOk],0);
end;

end.



